/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.7.24565 at Fri May 20 01:23:13 PM CEST 2016
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2016.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#include "t3rts.h"
#include "example_errorhandling.h"

/***************************************************************************/
#ifdef _WIN32   /* Win32 platform */
/***************************************************************************/

long
ex_process_EXCEPTION_ACCESS_VIOLATION(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_ACCESS_VIOLATION\n";
    err.detailed_description = "The thread attempted to read" \
            " from or write to a virtual address for which it does not have" \
            " the appropriate access.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER; 
}


long
ex_process_EXCEPTION_DATATYPE_MISALIGNMENT(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_DATATYPE_MISALIGNMENT\n";
    err.detailed_description = "The thread attempted to" \
             " read or write data that is misaligned on hardware that does" \
             " not provide alignment. For example, 16-bit values must be" \
             " aligned on 2-byte boundaries, 32-bit values on 4-byte" \
             " boundaries, and so on.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_BREAKPOINT(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_BREAKPOINT\n";
    err.detailed_description = "A breakpoint was encountered.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_SINGLE_STEP(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_SINGLE_STEP\n";
    err.detailed_description = "A trace trap or other" \
             " single-instruction mechanism signaled that one instruction" \
             " has been executed.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_ARRAY_BOUNDS_EXCEEDED(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_ARRAY_BOUNDS_EXCEEDED\n";
    err.detailed_description = "The thread attempted" \
             " to access an array element that is out of bounds, and the" \
             " underlying hardware supports bounds checking.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_FLT_DENORMAL_OPERAND(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_FLT_DENORMAL_OPERAND\n";
    err.detailed_description = "One of the operands in" \
             " a floating-point operation is denormal. A denormal value is" \
             " one that is too small to represent as a standard floating-point" \
             " value.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_FLT_DIVIDE_BY_ZERO(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_FLT_DIVIDE_BY_ZERO\n";
    err.detailed_description = "The thread attempted to" \
             " divide a floating-point value by a floating-point divisor" \
             " of zero.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_FLT_INEXACT_RESULT(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_FLT_INEXACT_RESULT\n";
    err.detailed_description = "The result of a" \
             " floating-point operation cannot be represented exactly as a" \
             " decimal fraction.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_FLT_INVALID_OPERATION(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_FLT_INVALID_OPERATION\n";
    err.detailed_description = "This exception represents" \
             " any floating-point exception not included in this list.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_FLT_OVERFLOW(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_FLT_OVERFLOW\n";
    err.detailed_description = "The exponent of a floating-point" \
             " operation is greater than the magnitude allowed by the" \
             " corresponding type.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_FLT_STACK_CHECK(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_FLT_STACK_CHECK\n";
    err.detailed_description = "The stack overflowed or" \
              " underflowed as the result of a floating-point operation.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_FLT_UNDERFLOW(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_FLT_UNDERFLOW\n";
    err.detailed_description = "The exponent of a floating-point" \
             " operation is less than the magnitude allowed by the" \
             " corresponding type.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}



long
ex_process_EXCEPTION_INT_DIVIDE_BY_ZERO(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGFPE - Floating point exception\n";
    err.detailed_description = "Division by zero.\n";

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_INT_OVERFLOW(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_INT_OVERFLOW\n";
    err.detailed_description = "The result of an integer" \
             " operation caused a carry out of the most significant bit" \
             " of the result.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_EXCEPTION_PRIV_INSTRUCTION(t3rt_context_t ctx)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "EXCEPTION_PRIV_INSTRUCTION\n";
    err.detailed_description = "The thread attempted to" \
             " execute an instruction whose operation is not allowed in" \
             " the current machine mode.\n";

    t3rt_report_fatal_system_error(err, ctx);

    /*NOTREACHED*/
    return EXCEPTION_EXECUTE_HANDLER;
}


long
ex_process_UNKNOWN_EXCEPTION(unsigned long exceptionCode,
                                t3rt_context_t ctx)
{
#ifdef DEBUG
    fprintf (stderr, "UNKNOWN EXCEPTION: code %Xh\n", exceptionCode);
#endif

    return EXCEPTION_CONTINUE_SEARCH;
}



long
ex_ProcessException(unsigned long exceptionCode, t3rt_context_t ctx)
{
    switch (exceptionCode) {
      case EXCEPTION_ACCESS_VIOLATION: 
          return ex_process_EXCEPTION_ACCESS_VIOLATION(ctx);

      case EXCEPTION_DATATYPE_MISALIGNMENT:
          return ex_process_EXCEPTION_DATATYPE_MISALIGNMENT(ctx);

      case EXCEPTION_BREAKPOINT:
          return ex_process_EXCEPTION_BREAKPOINT(ctx);

      case EXCEPTION_SINGLE_STEP:
          return ex_process_EXCEPTION_SINGLE_STEP(ctx);

      case EXCEPTION_ARRAY_BOUNDS_EXCEEDED:
          return ex_process_EXCEPTION_ARRAY_BOUNDS_EXCEEDED(ctx);

      case EXCEPTION_FLT_DENORMAL_OPERAND:
          return ex_process_EXCEPTION_FLT_DENORMAL_OPERAND(ctx);

      case EXCEPTION_FLT_DIVIDE_BY_ZERO:
          return ex_process_EXCEPTION_FLT_DIVIDE_BY_ZERO(ctx);

      case EXCEPTION_FLT_INEXACT_RESULT:
          return ex_process_EXCEPTION_FLT_INEXACT_RESULT(ctx);

      case EXCEPTION_FLT_INVALID_OPERATION:
          return ex_process_EXCEPTION_FLT_INVALID_OPERATION(ctx);

      case EXCEPTION_FLT_OVERFLOW:
          return ex_process_EXCEPTION_FLT_OVERFLOW(ctx);

      case EXCEPTION_FLT_STACK_CHECK:
          return ex_process_EXCEPTION_FLT_STACK_CHECK(ctx);

      case EXCEPTION_FLT_UNDERFLOW:
          return ex_process_EXCEPTION_FLT_UNDERFLOW(ctx);

      case EXCEPTION_INT_DIVIDE_BY_ZERO:
          return ex_process_EXCEPTION_INT_DIVIDE_BY_ZERO(ctx);

      case EXCEPTION_INT_OVERFLOW:
          return ex_process_EXCEPTION_INT_OVERFLOW(ctx);

      case EXCEPTION_PRIV_INSTRUCTION:
          return ex_process_EXCEPTION_PRIV_INSTRUCTION(ctx);

      default:
          return ex_process_UNKNOWN_EXCEPTION(exceptionCode, ctx);
      }

   /*NOTREACHED*/
   return EXCEPTION_CONTINUE_EXECUTION;
}


/***************************************************************************/
#else           /* Unix platform */
/***************************************************************************/

void
ex_set_signal_handlers (void)
{
    struct sigaction sig_act;
    
    sig_act.sa_sigaction = ex_signal_handler;
    sig_act.sa_flags = SA_SIGINFO;
    sigfillset(&sig_act.sa_mask);

    sigaction(SIGHUP, &sig_act, NULL);
    sigaction(SIGINT, &sig_act, NULL);
    sigaction(SIGQUIT, &sig_act, NULL);
    sigaction(SIGILL, &sig_act, NULL);
    sigaction(SIGABRT, &sig_act, NULL);
    sigaction(SIGFPE, &sig_act, NULL);
    sigaction(SIGBUS, &sig_act, NULL);
    sigaction(SIGSEGV, &sig_act, NULL);
    sigaction(SIGPIPE, &sig_act, NULL);
    sigaction(SIGTERM, &sig_act, NULL);
}


void 
ex_process_SIGHUP (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGHUP - Hangup\n";
    err.detailed_description = NULL;

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGINT (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGINT - Interrupt (rubout)\n";
    err.detailed_description = NULL;

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGQUIT (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGQUIT - Quit (ASCII FS)\n";
    err.detailed_description = NULL;

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGILL (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGILL - Illegal instruction\n";

    switch (info->si_code) {
    case ILL_ILLOPC:
        err.detailed_description = "Illegal opcode.\n";
        break;
    case ILL_ILLOPN:
        err.detailed_description = "Illegal operand.\n";
        break;
    case ILL_ILLADR:
        err.detailed_description = "Illegal addressing mode.\n";
        break;
    case ILL_ILLTRP:
        err.detailed_description = "Illegal trap.\n";
        break;
    case ILL_PRVOPC:
        err.detailed_description = "Privileged opcode.\n";
        break;
    case ILL_PRVREG:
        err.detailed_description = "Privileged register.\n";
        break;
    case ILL_COPROC:
        err.detailed_description = "Co-processor error.\n";
        break;
    case ILL_BADSTK:
        err.detailed_description = "Internal stack error.\n";
        break;
    default:
        err.detailed_description = NULL;
        break;
    }

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGABRT (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGABRT - Abort\n";
    err.detailed_description = NULL;

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGFPE (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGFPE - Floating point exception\n";

    switch (info->si_code) {
    case FPE_INTDIV:
        err.detailed_description = "Division by zero.\n";
        break;
    case FPE_INTOVF:
        err.detailed_description = "Integer overflow.\n";
        break;
    case FPE_FLTDIV:
        err.detailed_description = "Floating point divide by zero.\n";
        break;
    case FPE_FLTOVF:
        err.detailed_description = "Floating point overflow.\n";
        break;
    case FPE_FLTUND:
        err.detailed_description = "Floating point underflow.\n";
        break;
    case FPE_FLTRES:
        err.detailed_description = "Floating point inexact result.\n";
        break;
    case FPE_FLTINV:
        err.detailed_description = "Invalid floating point operation.\n";
        break;
    case FPE_FLTSUB:
        err.detailed_description = "Subscript out of range.\n";
        break;
    default:
        err.detailed_description = NULL;
        break;
    }

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGBUS (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGBUS - Bus error\n";

    switch (info->si_code) {
    case BUS_ADRALN:
        err.detailed_description = "Invalid address alignment.\n";
        break;
    case BUS_ADRERR:
        err.detailed_description = "Non-existent physical address.\n";
        break;
    case BUS_OBJERR:
        err.detailed_description = "Object specific hardware error.\n";
        break;
    default:
        err.detailed_description = NULL;
        break;
    }

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGSEGV (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGSEGV - Segmentation violation\n";

    switch (info->si_code) {
    case SEGV_MAPERR:
        err.detailed_description = "Address not mapped to object.\n";
        break;
    case SEGV_ACCERR:
        err.detailed_description = "Invalid permissions for mapped object.\n";
        break;
    default:
        err.detailed_description = NULL;
        break;
    }

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGPIPE (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGPIPE - Write on a pipe with no one to read it\n";
    err.detailed_description = NULL;

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_SIGTERM (siginfo_t * info, void * context)
{
    t3rt_error_description_t    err;

    err.error_code = 2;
    err.error_message = "SIGTERM - Software termination signal from kill\n";
    err.detailed_description = NULL;

    t3rt_report_fatal_system_error (err, NULL);

    /*NOTREACHED*/
    return;
}


void 
ex_process_unknown_SIG (int signo, siginfo_t * info, void * context)
{
#ifdef DEBUG
    fprintf (stderr, "UNKNOWN SIGNAL: code %d\n", signo);
    fprintf (stderr, "EXTRA INFO: si_errno %d, si_code %d\n", 
                    info->si_errno, info->si_code);
#endif

    return;
}


void 
ex_restore_SIGABRT_signal_handler (void)
{
    struct sigaction sig_act;
  
    sig_act.sa_sigaction = (void (*)())SIG_DFL;
    sig_act.sa_flags = 0;
    sigfillset(&sig_act.sa_mask);

    /* abort() will work correctly */
    sigaction(SIGABRT, &sig_act, NULL);
}


void 
ex_signal_handler (int signo, siginfo_t * info, void * context)
{
    switch (signo) {
    case SIGHUP:
        ex_process_SIGHUP (info, context);
        break;
    case SIGINT:
        ex_process_SIGINT (info, context);
        break;
    case SIGQUIT:
        ex_process_SIGQUIT (info, context);
        break;
    case SIGILL:
        ex_process_SIGILL (info, context);
        break;
    case SIGABRT:
        ex_process_SIGABRT (info, context);
        break;
    case SIGFPE:
        ex_process_SIGFPE (info, context);
        break;
    case SIGBUS:
        ex_process_SIGBUS (info, context);
        break;
    case SIGSEGV:
        ex_process_SIGSEGV (info, context);
        break;
    case SIGPIPE:
        ex_process_SIGPIPE (info, context);
        break;
    case SIGTERM:
        ex_process_SIGTERM (info, context);
        break;
    default:
        ex_process_unknown_SIG (signo, info, context); /* should never happen */
        break;
    }

    return;
}


/***************************************************************************/
#endif              
/***************************************************************************/

void
t3pl_normalize_abort_operation() {
  ex_normalize_abort_operation();
}

