/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.7.24565 at Fri May 20 01:23:13 PM CEST 2016
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2016.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __example_errorhandling_h
#define __example_errorhandling_h

#include "t3rts.h"

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************************/
#ifdef _WIN32   /* Win32 platform */
/***************************************************************************/

#include <windows.h>

#if defined(DEBUG) || defined(WIN32_GCC)
#define TRY_EXCEPTION
#define CATCH_EXCEPTION(ctx)
#else
#define TRY_EXCEPTION     __try
#define CATCH_EXCEPTION(ctx) \
  __except(ex_ProcessException(GetExceptionCode(), ctx)) {}
#endif

long
ex_ProcessException(unsigned long exceptionCode, t3rt_context_t ctx);


long
ex_process_EXCEPTION_ACCESS_VIOLATION(t3rt_context_t ctx);
    
long
ex_process_EXCEPTION_DATATYPE_MISALIGNMENT(t3rt_context_t ctx);

long
ex_process_EXCEPTION_BREAKPOINT(t3rt_context_t ctx);

long
ex_process_EXCEPTION_SINGLE_STEP(t3rt_context_t ctx);

long
ex_process_EXCEPTION_ARRAY_BOUNDS_EXCEEDED(t3rt_context_t ctx);

long
ex_process_EXCEPTION_FLT_DENORMAL_OPERAND(t3rt_context_t ctx);

long
ex_process_EXCEPTION_FLT_DIVIDE_BY_ZERO(t3rt_context_t ctx);

long
ex_process_EXCEPTION_FLT_INEXACT_RESULT(t3rt_context_t ctx);

long
ex_process_EXCEPTION_FLT_INVALID_OPERATION(t3rt_context_t ctx);

long
ex_process_EXCEPTION_FLT_OVERFLOW(t3rt_context_t ctx);

long
ex_process_EXCEPTION_FLT_STACK_CHECK(t3rt_context_t ctx);

long
ex_process_EXCEPTION_FLT_UNDERFLOW(t3rt_context_t ctx);

long
ex_process_EXCEPTION_INT_DIVIDE_BY_ZERO(t3rt_context_t ctx);

long
ex_process_EXCEPTION_INT_OVERFLOW(t3rt_context_t ctx);

long
ex_process_EXCEPTION_PRIV_INSTRUCTION(t3rt_context_t ctx);

long
ex_process_UNKNOWN_EXCEPTION(unsigned long exceptionCode,
                             t3rt_context_t ctx);


#define ex_normalize_abort_operation() /* empty, don't need it for Windows */


/***************************************************************************/
#else           /* Unix platform */
/***************************************************************************/

#include <signal.h>
#include <sys/errno.h>

#ifndef LINUX
#include <siginfo.h>
#endif

#define TRY_EXCEPTION     ex_set_signal_handlers ();
#define CATCH_EXCEPTION(ctx) /* Do nothing, catch is in signal handlers */

void
ex_set_signal_handlers (void);

void 
ex_signal_handler (int signo, siginfo_t * info, void * context);

void
ex_process_SIGHUP (siginfo_t * info, void * context);

void
ex_process_SIGINT (siginfo_t * info, void * context);

void
ex_process_SIGQUIT (siginfo_t * info, void * context);

void
ex_process_SIGILL (siginfo_t * info, void * context);

void
ex_process_SIGABRT (siginfo_t * info, void * context);

void
ex_process_SIGFPE (siginfo_t * info, void * context);

void
ex_process_SIGBUS (siginfo_t * info, void * context);

void
ex_process_SIGSEGV (siginfo_t * info, void * context);

void
ex_process_SIGPIPE (siginfo_t * info, void * context);

void
ex_process_SIGTERM (siginfo_t * info, void * context);

void
ex_process_unknown_SIG (int signo, siginfo_t * info, void * context);


void
ex_restore_SIGABRT_signal_handler (void);

#define ex_normalize_abort_operation() ex_restore_SIGABRT_signal_handler()


/***************************************************************************/
#endif              
/***************************************************************************/


void
t3pl_normalize_abort_operation();


#ifdef __cplusplus
}
#endif

#endif /* __example_errorhandling_h */
